// Module: MatrixColumn
// Author: Hassan Siddiqui
//
// Description:
// Special class to handle creation, reading and writing to the RMF
// MATRIX column. This is special as it can be of variable or fixed
// length vector type.
// 
// Comments: 
//  
// Modifications: See ChangeLog
// 
// $Id: MatrixColumn.h,v 1.1 2000/03/07 13:49:43 hsiddiqu Exp $

#ifndef MatrixColumn_H
#define MatrixColumn_H

/* General */

/* SAS-specific */
#include "Dal.h"

/* Local */

/*******************************
 *
 * class MatrixColumn
 *
 *******************************/

class MatrixColumn
{

public:

  /* Constructor */
  MatrixColumn() {PROC; ENDPROC;}

  /* Destructor */
  virtual ~MatrixColumn(){PROC; ENDPROC;}

  /* Set state to a particular row, and the size of that row */
  virtual void row( unsigned long row,
		    unsigned int elements ) = 0;

  /* Write to a given position in row */
  virtual void writeTo( unsigned int element,
			double value) = 0;

  /* The number of elements in row */
  virtual unsigned int rowElements() const = 0;

  /* Inform class that processing for current row is complete */
  virtual void closeRow() = 0;

protected:

private:

};

#endif
