// Module: VarMatrixColumn
// Author: Hassan Siddiqui
//
// Description:
// Variable length vector column representation of MatrixColumn.
// 
// Comments: 
//  
// Modifications: See ChangeLog
// 
// $Id: VarMatrixColumn.h,v 1.1 2000/03/07 13:49:44 hsiddiqu Exp $

#ifndef VarMatrixColumn_H
#define VarMatrixColumn_H

/* General */

/* SAS-specific */
#include "Dal.h"

/* Local */
#include "MatrixColumn.h"

/*******************************
 *
 * class VarMatrixColumn
 *
 *******************************/

class VarMatrixColumn : public MatrixColumn
{

public:

  /* Constructor */
  VarMatrixColumn( Table * table );

  /* Destructor */
  ~VarMatrixColumn();

  /* Write to a given position in row */
  void writeTo( unsigned int element,
		double value);

  /* Set the number of elements in row */
  void row( unsigned long row,
	    unsigned int  elements);

  /* The number of elements in row */
  unsigned int rowElements() const;

  /* Inform class that processing for current row is complete */
  void closeRow();

private:

  Column     *  _matrixCol;
  unsigned long _row;
  CellData  *   _cellData;
  unsigned int  _rowelements;
};

#endif
